package logic.module2;

import java.io.IOException;
import java.io.Reader;


import org.apache.log4j.Logger;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.LowerCaseFilter;
import org.apache.lucene.analysis.LowerCaseTokenizer;
import org.apache.lucene.analysis.StopFilter;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.WhitespaceTokenizer;

public class CustomAnalyzer extends Analyzer {
	
//	private final String stopPath = "C:\\Users\\Klæboe\\Skole\\MASTER\\MEDLINE\\SAMPLE2010\\stopwords.txt"; 
	private Logger log = Logger.getLogger(this.getClass());
	private static CustomAnalyzer instance = null;
	
	private final String[] STOPWORDS = {
			"a", "about", "again", "all", "almost", "also", "although", "always", "among", "an", "and",
			"another", "any", "are", "as", "at", "be", "because", "been", "before", "being", "between",
			"both", "but", "by", "can", "could", "did", "do", "does", "done", "due", "during", "each",
			"either", "enough", "especially", "etc", "for", "found", "from", "further", "had", "has",
			"have", "having", "here", "how", "however", "i", "if", "in", "into", "is", "it", "its",
			"itself", "just", "kg", "km", "made", "mainly", "make", "many", "may", "mg", "might", "ml", "mm",
			"most", "mostly", "must", "nearly", "neither", "no", "nor", "obtained", "of", "often", "on", "or",
			"our", "overall", "perhaps", "proteins", "pmid", "quite", "rather", "really", "regarding", "seem", "seen",
			"several", "should", "show", "showed", "shown", "shows", "significantly", "since", "so", "some",
			"such", "than", "that", "the", "their", "theirs", "them", "then", "there", "therefore", "these",
			"they", "this", "those", "through", "thus", "to", "upon", "use", "used", "using", "various", 
			"very", "was", "we", "were", "what", "when", "which", "while", "with", "within", "without",
			"would"
	};
	private TokenStream stream;

	public CustomAnalyzer() {
		super();
	}
	
	public static CustomAnalyzer getInstance() {
		if(instance == null) {
			instance = new CustomAnalyzer();
		}
		
		return instance;	
	}

	@Override
	public TokenStream tokenStream(String fieldName, Reader reader) {
		
		stream = new StopFilter(false, new LowerCaseFilter(new WhitespaceTokenizer(reader)), StopFilter.makeStopSet(STOPWORDS, true));
		
		return stream; 
	}
}
