package logic.module3;

public class Entity implements Comparable<Entity> {

	private String section;
	private String offset[];
	private String element;
	
	public Entity(String s1, String s2, String s3) {
		section = s1;
		offset = s2.split("-");
		element = s3;
	}
	
	public String getSection() {
		return this.section;
	}
	
	public String[] getOffset() {
		return this.offset;
	}
	
	public String getElement() {
		return this.element;
	}
	
	@Override
	public String toString() {
		return section+":"+offset[0]+"-"+offset[1]+":"+element;
	}
	
	@Override
	public boolean equals(Object o) {
        if (!(o instanceof Entity))
            return false;
        
        boolean offsetCheck = this.offset[0].equals(((Entity)o).offset[0]) && this.offset[1].equals(((Entity)o).offset[1]);
        
        return this.section.equals(((Entity)o).section) && offsetCheck && this.element.equals(((Entity)o).element);
    }

	@Override
	public int compareTo(Entity e) {		
		int sectionCompare = section.compareTo(e.section);
		boolean offsetCompare = (Integer.parseInt(offset[0]) < Integer.parseInt(e.offset[0]));
		
		if(this.equals(e)) {
			return 0;
		} else if(sectionCompare == 0) {
			if(offsetCompare) {
				return -1;
			} else {
				return 1;
			}			
		} else if(sectionCompare > 0){
			return -1;
		}
		
		return 1;
	}
}
