package logic.module3;

public class PreQueryProcess {
	
	public static String escapeForFullQuery(String workingText) {
		String newText = workingText.replaceAll("\\.$", "");
		newText = newText.replaceAll("^|$", "\"");

		return newText;
	}
	
	public static String partOfNamePreProcess(String workingText) {
		String newText = workingText.replaceAll("[\\(\\[\\)\\]\\-\\_\\/\\:\\'\\{\\}\\~\\+\\\"\\*]", " ");
		newText = newText.replaceAll("\\.$", "");
		newText = newText.replaceAll("^[+].", "");
		return newText;
	}
	
	public static boolean useableTokenCheck(String token) {
		
		if(token == null) {
//			System.out.println("Token was null");
			return false;
		} else if(token.matches("\\s*|\\s*+,")) {
//			Should match a string with just whitespaces
			return false;
		} else if (token.isEmpty()) {
//			System.out.println("Token was empty");
			return false;
		} else if (token.matches("^[\\+\\(\\)\\%\\'\\\"\\-]+$")) {
//			System.out.println("Token consist of one or a combination of + ( % '");
			return false;
		} else if(token.equals("\"")) {
//			System.out.println("Token just contains a \"");
			return false;		
		} else {
			return true;
		}		
		
	}
}
