package logic.module4;

import java.util.ArrayList;
import java.util.Map;

import logic.module3.Entity;

public class Evaluation {
	
	private Map<String, ArrayList<Entity>> pmidToProteinHits;
	private Map<String, ArrayList<Entity>> pmidTokeywordHits;
	private ArrayList<String> pmidList;
	private Output out;
	private ArrayList<Entity> proteins;
	private ArrayList<Entity> keywords;
	private Entity prev;
	private boolean interaction;
	
	public Evaluation(Map<String, ArrayList<Entity>> map1, Map<String, ArrayList<Entity>> map2, ArrayList<String> alist) {
		pmidToProteinHits = map1;
		pmidTokeywordHits = map2;
		pmidList = alist;
		interaction = false;
		out = new Output("results.txt");
		
		this.eval();
		out.close();
	}
	
	private void eval() {
		for(String s : pmidList) {
			proteins = pmidToProteinHits.get(s);
			keywords = pmidTokeywordHits.get(s);
			
			if(proteins != null && proteins.size() > 1 && keywords != null) {
				for(Entity e : keywords) {
					prev = proteins.get(0);
					proteins.remove(0);
					
					for(Entity proteinEntity : proteins) {						
						if(this.checkLocation(prev.getOffset(), e.getOffset(), proteinEntity.getOffset())) {
							interaction = true;
						} else {
							prev = proteinEntity;
							interaction = false;
						}
					}
				}
				
				if(interaction) out.write(s + "\tP");
				else out.write(s +"\tN");
				
			} else {
				out.write(s + "\tN");
			}			
		}		
	}
	
	private boolean checkLocation(String[] o1, String[] o2, String[] o3) {
		int pos1 = Integer.parseInt(o1[1]);
		int pos2 = Integer.parseInt(o2[0]);
		int pos3 = Integer.parseInt(o2[1]);
		int pos4 = Integer.parseInt(o3[0]);
		
		if(pos1 < pos2 && pos3 < pos4) return true;
		else return false;
	}
}
