package testing.biocreative;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public class Tester {
	
	private File answerFile, resultsFile;
	private ArrayList<Integer> pmidList;
	private Map<Integer, String> pmidToAnswer, pmidToResult;
	private BufferedReader bfAnswerReader, bfResultReader;
	private String readLine;
	private String[] readLinePieces;
	
	public Tester(String path1, String path2) {
		answerFile = new File(path1);
		resultsFile = new File(path2);
		
		pmidList = new ArrayList<Integer>();
		pmidToAnswer = new HashMap<Integer, String>();
		pmidToResult = new HashMap<Integer, String>();
		
		this.makePmidListAndAnswerMap();
		this.makeResultMap();
		this.eval();
	}
	
	private void makePmidListAndAnswerMap() {
		try {
			bfAnswerReader = new BufferedReader(new FileReader(answerFile));
			readLine = bfAnswerReader.readLine();
			
			while(readLine != null) {
				readLinePieces = readLine.split("\\s");				
				pmidList.add(Integer.parseInt(readLinePieces[0]));				
				pmidToAnswer.put(Integer.parseInt(readLinePieces[0]), readLinePieces[1]);				
				readLine = bfAnswerReader.readLine();
			}			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		Collections.sort(pmidList);
	}
	
	private void makeResultMap() {		
		try {
			bfResultReader = new BufferedReader(new FileReader(resultsFile));
			readLine = bfResultReader.readLine();
			
			while(readLine != null) {
				readLinePieces = readLine.split("\\s");
				pmidToResult.put(Integer.parseInt(readLinePieces[0]), readLinePieces[1]);
				readLine = bfResultReader.readLine();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}	
	}
	
	private void eval() {
		int postiveHits = 0;
		int negativeHits = 0;
		int hits = 0;
		
		for(Integer i : pmidList) {
			System.out.println(i + ": " + pmidToAnswer.get(i) + " vs " + pmidToResult.get(i));
			if((pmidToAnswer.get(i)).equals(pmidToResult.get(i))) {
				if(pmidToAnswer.get(i).equals("P")) {
					postiveHits++;
				} else {
					negativeHits++;
				}
					
				hits++;
			}
		}
		
		System.out.println("Of " + pmidList.size() + " possible, there were " + hits + " matching pairs");
		System.out.println("Of these again, " + postiveHits + " where positive hits, and " + negativeHits + " were negative hits");

	}
	
	public static void main(String[] args) {
		new Tester("C:\\Users\\Klæboe\\Skole\\MASTER\\Master.java\\TestData\\BIOias_test_pmid2label.txt", "C:\\Users\\Klæboe\\Skole\\MASTER\\Master.java\\TestData\\BIOresults.txt");
	}
}
