package testing.yapex;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import logic.module1.NonFuncCharRemoval;
import logic.module4.Output;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class AnswerSetMaker {
	
	private static final String FILEPATH = "C:\\Users\\Klæboe\\Skole\\MASTER\\yapex_text_collection\\yapex_test_collection.xml";
	
	private File fileOrDir;
	private Output out;
	private NonFuncCharRemoval nfcr;
	private ArrayList<YapexProtein> proteinList;
	public AnswerSetMaker() {
		
		fileOrDir = new File(FILEPATH);
		out = new Output("yapax_answers.txt");
		nfcr = new NonFuncCharRemoval();
		proteinList = new ArrayList<YapexProtein>();
		
		try {
			DocumentBuilder docBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document xmlDoc = docBuilder.parse(fileOrDir);
			
			NodeList proteinNameList = xmlDoc.getElementsByTagName("Protname");
			
			for(int i = 0; i < proteinNameList.getLength(); i++) {
				
				Node n = proteinNameList.item(i);
				Node parent = n.getParentNode();
				Node pmid = n.getParentNode();				
				
				if(parent.getNodeName().equals("ArticleTitle")) {
					pmid = pmid.getPreviousSibling().getPreviousSibling();
					YapexProtein yp = new YapexProtein(pmid.getTextContent(), "Title", nfcr.preProcessInit(n.getTextContent()));
					if(!proteinList.contains(yp)) {
						proteinList.add(yp);
					}					
				} else if(parent.getNodeName().equals("AbstractText")) {
					pmid = pmid.getPreviousSibling().getPreviousSibling().getPreviousSibling().getPreviousSibling();
					YapexProtein yp = new YapexProtein(pmid.getTextContent(), "Abstract", nfcr.preProcessInit(n.getTextContent()));
					if(!proteinList.contains(yp)) {
						proteinList.add(yp);
					}
					
				}
			}
			
			Collections.sort(proteinList);
			for(YapexProtein yp : proteinList) {
				out.write(yp.toString());
			}
			
			out.close();			
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		new AnswerSetMaker();
	}
}
