package testing.yapex;

public class YapexProtein implements Comparable<YapexProtein>{
	private String pmid;
	private String field;
	private String name;
	
	public YapexProtein(String s1, String s2, String s3) {
		pmid = s1;
		field = s2;
		name = s3;
	}
	
	public String getPMID() {
		return this.pmid;
	}
	
	public String getField() {
		return this.field;
	}
	
	public String getName() {
		return this.name;
	}

	@Override
	public String toString() {
		return pmid + ":" + field + ":" + name;
	}
	
	@Override
	public boolean equals(Object o) {
		if (!(o instanceof YapexProtein))
            return false;
        
        return this.pmid.equals(((YapexProtein)o).pmid) && this.field.equals(((YapexProtein)o).field) && this.name.equals(((YapexProtein)o).name);
	}

	@Override
	public int compareTo(YapexProtein yp) {
		
		int fieldCompare = field.compareTo(yp.field);
		boolean pmidEqual = Integer.parseInt(pmid) == Integer.parseInt(yp.pmid);
		boolean pmidLower = Integer.parseInt(pmid) < Integer.parseInt(yp.pmid);
		
		if(this.equals(yp)) {
			return 0;
		} else if(pmidEqual) {
			if(fieldCompare > 0) {
				return -1;
			}
		} else if(pmidLower) {
			return -1;
		} else {
			return 1;
		}
		
		return 1;
	}

}
